"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var from_dir_1 = require("./from-dir");
var string_builder_1 = require("./string-builder");
var fs = require("fs");
var path = require("path");
exports.build = function (rootPath) {
    var importStatements = new string_builder_1.StringBuilder();
    var content = new string_builder_1.StringBuilder();
    var home = path.resolve(rootPath);
    var sandboxCount = 0;
    var sandboxes = [];
    from_dir_1.fromDir(home, /\.sandbox.ts$/, function (filename) {
        var filePathToUse = filename.replace(home, '.').replace(/.ts$/, '').replace(/\\/g, '/');
        var contents = fs.readFileSync(filename, 'utf8');
        var match = / sandboxOf\(\s*([^)]+?)\s*\)/g.exec(contents);
        if (match) {
            var typeName = match[1].split(',')[0].trim();
            var importName = "s" + ++sandboxCount;
            sandboxes.push({ importName: importName, typeName: typeName });
            importStatements.addLine("import { default as " + importName + " } from '" + filePathToUse + "';");
        }
    });
    content.addLine("export let sandboxes: any[] = [];");
    sandboxes.forEach(function (_a) {
        var importName = _a.importName, typeName = _a.typeName;
        content.addLine("sandboxes.push(" + importName + ".serialize('" + typeName + "'));");
    });
    var filePath = path.resolve(home, './sandboxes.ts');
    fs.writeFile(filePath, importStatements.dump() + content.dump(), function (err) {
        if (err) {
            return console.log(err);
        }
        console.log("Created file: " + filePath);
    });
};
