export interface SandboxOfConfig {
    prependText?: string;
    imports?: any[];
    declarations?: any[];
    providers?: any[];
    declareComponent?: boolean;
}
export interface ScenarioConfig {
    template: string;
    styles?: string[];
    context?: any;
    providers?: any[];
}
export declare function sandboxOf(type: any, config?: SandboxOfConfig): SandboxBuilder;
export declare class SandboxBuilder {
    private _type;
    private _config;
    private _prependTextAsKey;
    private _scenarios;
    private _scenarioCounter;
    constructor(_type: any, _config?: SandboxOfConfig);
    add(description: string, config: ScenarioConfig): this;
    serialize(typeName: string): {
        key: string;
        name: string;
        type: any;
        scenarios: any[];
        prependText: string;
        imports: any[];
        declarations: any[];
        providers: any[];
        declareComponent: boolean;
    };
}
